package eu.DECIDEh2020.mcsla.editor.data;
/*
* Copyright (c) 2017 Fraunhofer FOKUS.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the
* <<licensing_schema_to_be_decided>> which accompanies
* this distribution, and is available at
* https://opensource.org/licenses/EPL-2.0
*
* Contributors:
*
* Majid Salehi Ghamsari Fraunhofer FOKUS
**Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
*/
import java.util.Arrays;
import java.util.List;

import eu.DECIDEh2020.mcsla.editor.JerseyClient;
import eu.DECIDEh2020.mcsla.beans.MicroserviceSLA;
import eu.DECIDEh2020.mcsla.beans.MicroserviceSLO;
import eu.DECIDEh2020.mcsla.beans.MicroserviceSQO;

public class SlasData {

	static List<MicroserviceSLO> slos;
	static List<MicroserviceSQO> sqos;
	static List<MicroserviceSLO> aggs;
	static MicroserviceSLA[] slas;

	public static List<MicroserviceSLO> getAllAGGs() {
		//System.out.println("SlasData:getAllAGGs:....");
		JerseyClient jerseyClient = new JerseyClient();
		if (slas == null)
			slas = jerseyClient.getCspSLAs();
		// Prepare SLOs to send to MCSLA Aggregator
		MicroserviceSLO[] microserviceSLOs = jerseyClient.buildSLOs(slas);
		//System.out.println("getAllAGGs:got list SLOs:" + microserviceSLOs.length);
		// Return aggregated SLO
		MicroserviceSLO aggregatedSLO = jerseyClient.applyAggregationRules(microserviceSLOs);
		if (aggregatedSLO != null)
			System.out.println("SlasData:getAllAGGs:got aggregated SLO:" + aggregatedSLO.termName);
		else
			System.out.println("SlasData:getAllAGGs:got aggregated SLO is NULL :-(");
		aggs = Arrays.asList(aggregatedSLO);
		//System.out.println("SlasData:getAllAGGs:" + aggs.size());
		return aggs;
	}

	public static List<MicroserviceSLO> getAllSLOs() {
		//System.out.println("SlasData:getAllSLOs:....");
		JerseyClient jerseyClient = new JerseyClient();
		if (slos == null) {
			slos = Arrays.asList(jerseyClient.buildSLOs(jerseyClient.getCspSLAs()));
		}
		System.out.println("SlasData:getAllSLOs:" + slos.size());
		return slos;
	}

	public static List<MicroserviceSQO> getAllSQOs() {
		//System.out.println("SlasData:getAllSQOs:....");
		JerseyClient jerseyClient = new JerseyClient();
		if (sqos == null) {
			sqos = Arrays.asList(jerseyClient.buildSQOs(jerseyClient.getCspSLAs()));
		}
		System.out.println("SlasData:getAllSQOs:" + sqos.size());
		return sqos;
	}

}
